<template>
  <v-main class="mainStyle">
    <v-card class="mb-3 bg-blue-darken-4">
      <h2 class="m-3">Mein Profil</h2>
    </v-card>
    <v-card class="d-flex flex-column align-center justify-content-evenly mb-2">
      <img @click="userAvatar = !userAvatar" class="img-style mt-3" src="http://localhost:8080/api/files/avatar.jfif">
      <upload-image v-show="userAvatar"></upload-image>
      <!--    <v-btn @click="userAvatar = !userAvatar">Change Avatar</v-btn>-->
      <h2>username: {{authStore.user.username}}</h2>
      <p>{{authStore.user.email}}</p>
      <p v-if="authStore.user.role === 'ADMIN'">Admin</p>
      <p v-if="authStore.user.role === 'MANAGER'">Abteilungsleiter</p>
      <p v-if="authStore.user.role === 'USER'">Mitarbeiter</p>
    </v-card>
    <v-card class="mt-2">
      <v-form v-if="editUser" @submit.prevent>
        <table class="table">
          <thead>
          <tr>
            <th>Vorname</th>
            <th>Nachname</th>
            <th>Geburtsdatum</th>
            <th>Abteilung</th>
          </tr>
          </thead>
          <tbody>
          <tr>
            <td>
              <v-text-field
                  v-model="authStore.user.firstName"
                  label="Vorname">
              </v-text-field>
            </td>

            <td>
              <v-text-field
                  v-model="authStore.user.lastName"
                  label="Nachname">
              </v-text-field>
            </td>
            <td>
              <v-text-field
                  v-model="authStore.user.birthday"
                  label="Geburtsdatum">
              </v-text-field>
            </td>
            <td>
              <v-text-field
                  v-model="authStore.user.department"
                  label="Abteilung">
              </v-text-field>
            </td>
          </tr>
          </tbody>
        </table>
        <v-btn block color="green-darken-3" @click="editUser = !editUser">Bestätigen</v-btn>
      </v-form>
    </v-card>

    <v-card v-if="!editUser" class="d-flex flex-column align-center justify-content-evenly">
      <table class="m-3 table table-hover table-bordered text-center">
        <thead>
        <tr>
          <th>Vorname</th>
          <th>Nachname</th>
          <th>Geburtsdatum</th>
          <th>Abteilung</th>
          <th>Aktionen</th>
        </tr>
        </thead>
        <tbody>
        <tr>
          <td>{{authStore.user.firstName}}</td>
          <td>{{authStore.user.lastName}}</td>
          <td>{{authStore.user.birthday}}</td>
          <td>{{authStore.user.department}}</td>
          <td><edit-user-dialog
              :page="1"
              :user="authStore.user"
          ></edit-user-dialog></td>
        </tr>
        </tbody>

      </table>

      <!--    <v-btn class="m-2" block color="warning" @click="editUser = !editUser">Bearbeiten</v-btn>-->
      <div style="width: 50%">
        <v-btn
            v-show="!changePassword"
            @click="changePassword = !changePassword"
            class="m-3"
            block
            color="blue-darken-4">Passwort ändern</v-btn>
        <v-btn
            v-show="changePassword"
            @click="changePassword = !changePassword"
            class="m-3"
            block
            color="blue-darken-4">Passwort nicht ändern</v-btn>
      </div>


    </v-card>

    <v-card class="mt-2">
      <v-form @submit.prevent="submitNewPassword">
        <!--      <v-text-field
                  style="width: 100%"
                  v-show="changePassword"
                  label="Username"
                  v-model="credentials.username"
              >
              </v-text-field>-->

        <v-text-field
            style="width: 100%"
            v-show="changePassword"
            label="Altes Passwort"
            type="password"
            v-model="credentials.password"
            autocomplete="oldPassword"
        >
        </v-text-field>

        <v-text-field
            style="width: 100%"
            v-show="changePassword"
            label="Neues Passwort"
            type="password"
            v-model="newPassword.newPassword"
            autocomplete="newPassword"
        >
        </v-text-field>
        <v-text-field
            style="width: 100%"
            v-show="changePassword"
            label="Neues Passwort Bestätigen"
            type="password"
            v-model="checkPassword.checkPassword"
            autocomplete="newPassword"
        >
        </v-text-field>
        <div>
          <v-btn
              type="submit"
              v-show="changePassword"
              color="green-darken-3"
              block >Bestätigen</v-btn>
        </div>

      </v-form>
    </v-card>



    <v-card class="mt-5">
      <UserTicketHistory></UserTicketHistory>
    </v-card>
  </v-main>



</template>

<script setup>

import {useAuthStore} from "@/stores/authStore";
import {computed, ref} from "vue";
import UserTicketHistory from "@/components/UserTicketHistory.vue";
import EditUserDialog from "@/components/dialogs/EditUserDialog.vue";
import UploadImage from "@/components/FileUpload.vue";
import {useUserStore} from "@/stores/userStore";

const authStore = useAuthStore();
const userStore = useUserStore();
const editUser = ref(false);
let userAvatar = ref(false);
let changePassword = ref(false);
const user = computed(() => authStore.user)
const credentials = ref({
  username: authStore.user.username,
  password: ""
});
const newPassword = ref({
  newPassword: ""
})
const checkPassword = ref({
  checkPassword: ""
})

async function submitNewPassword() {
  try {
    let response = confirm("Willst du dein Passwort ändern?")
    if (response) {
      await authStore.login(credentials.value)

      if (checkPassword.value.checkPassword === newPassword.value.newPassword) {
        await userStore.changePassword(authStore.user.userId, newPassword.value)
        alert("Passwort wurde erfolgreich geändert.")
        changePassword.value = false;
      } else {
        alert("Die Passwörter stimmen nicht überein.")
      }

    } else {
      changePassword.value = false;
    }
  } catch (error) {
    alert("Das angegebene Passwort ist falsch, bitte überprüfe deine Eingaben.")
    console.log("error", error)
  }
}
</script>

<style scoped>

.mainStyle{
  min-height: 100vh;
}

.img-style {
  width: 140px;
  border-radius: 115px;
  cursor: pointer;
}

</style>